Unit CFile;
{$I-}

Interface

Const
  SEEK_SET = 0;
  SEEK_CUR = 1;
  SEEK_END = 2;

Type
  pFile = ^File;

Function  FOpen(Filename, Format : String) : pFile;
Procedure FClose(FP : pFile);
Function  FSeek(FP : pFile; Position, Flag : Longint) : Longint;
Function  FTell(FP : pFile) : Longint;
Function  FRead(Var Buf; ElementSize, ElementCount : Longint; FP : pFile) : Longint;

Implementation

Function  FRead(Var Buf; ElementSize, ElementCount : Longint; FP : pFile) : Longint;

Var
  NumRead : Integer;

Begin
  if (FP = NIL)
    Then Begin
      FRead := 0;
      Exit;
    End;

  BlockRead(FP^, Buf, ElementSize * ElementCount, NumRead);
  FRead := NumRead;
End;

Function  FTell(FP : pFile) : Longint;

Begin
  if (FP = NIL)
    Then Begin
      FTell := -1;
      Exit;
    End;

  FTell := FilePos(FP^);
End;

Function  FSeek(FP : pFile; Position, Flag : Longint) : Longint;

Var
  CurrPos : Longint;

Begin
  if (FP = NIL)
    Then Begin
      FSeek := 1;
      Exit;
    End;

  Case Flag of
    SEEK_SET : Begin
                 Seek(FP^, Position);
               End;
    SEEK_CUR : Begin
                 CurrPos := FilePos(FP^);
                 Seek(FP^, CurrPos + Position);
               End;
    SEEK_END : Begin
                 CurrPos := FileSize(FP^);
                 Seek(FP^, CurrPos + Position);
               End;
    Else      Begin
                 FSeek := 1;
                 Exit;
               End;
  End;
  FSeek := 0;
End;

Function  FOpen(Filename, Format : String) : pFile;

Var
  TempFile : pFile;

Begin
  New(TempFile);

  Assign(TempFile^, Filename);

  if (Format[1] = 'w') or (Format[1] = 'W')
    Then ReWrite(TempFile^, 1)
    Else Begin
      if (Format[1] = 'r') or (Format[1] = 'R')
        Then Reset(TempFile^, 1)
        Else Begin
          Dispose(TempFile);
          FOpen := NIL;
          Exit;
        End;
    End;

  FOpen := TempFile;
End;

Procedure FClose(FP : pFile);

Begin
  if (FP <> NIL)
    Then Begin
      Close(FP^);
      Dispose(FP);
    End;
End;

End.